//==============================================================================
//
// Zap I/O WDM Device Driver
//
// nt ȯ濡 I/O Ʈ ׼   ִ  ϴ ̹ Դϴ.
//
//  -  : 2003 1 4
//  -  : 
//  - ̸ : AlphaMCU@hanmail.net
//  - ּ : http://www.zap.pe.kr
//
//  - Copyright (C) 2002~2003 Kyung-Ryul Sun.
//
//==============================================================================

#include "zapio.h"


//==============================================================================
//
// Undocumented Functions..
//
// WARNING :  Լ 80386 Ű μ  ڵ ̷ 
//  Ƿ Ƽ÷ ҽ  ʴ.
//
//==============================================================================
__declspec(dllimport) void Ke386SetIoAccessMap(int, IOPM *);
__declspec(dllimport) void Ke386QueryIoAccessMap(int, IOPM *);
__declspec(dllimport) void Ke386IoSetAccessProcess(PEPROCESS, int);


//==============================================================================
//
// NTDDK.h Ǿ ִ Լϵ.. (WDM ϱ )
//
//==============================================================================
__declspec(dllimport) void* MmAllocateNonCachedMemory(IN SIZE_T NumberOfBytes);
__declspec(dllimport) void  MmFreeNonCachedMemory(IN PVOID BaseAddress, IN SIZE_T NumberOfBytes);


//==============================================================================
//
//  ȣǴ Լ ..
//
//==============================================================================
NTSTATUS Dispatch_CompleteRequest(IN PIRP pIrp, IN NTSTATUS status, IN ULONG information);
NTSTATUS Dispatch_CompletionRoutine(IN PDEVICE_OBJECT pFdo, IN PIRP pIrp, IN PVOID pEvent);


//==============================================================================
//
// Paged Pool (Mapping) Լ ϵ. (passive level)
//
//==============================================================================
#ifdef ALLOC_PRAGMA
#pragma alloc_text (INIT, DriverEntry)
#pragma alloc_text (PAGE, Entry_Unload)
#pragma alloc_text (PAGE, Entry_AddDevice)
#pragma alloc_text (PAGE, Entry_DispatchCreate)
#pragma alloc_text (PAGE, Entry_DispatchClose)
#pragma alloc_text (PAGE, Dispatch_CompletionRoutine)
#endif


//==============================================================================
//
// DriverEntry
//
//  Լ Entry Point Ѵ.
//
// IRQL: It is run in the context of a system thread at IRQL PASSIVE_LEVEL.
//
//==============================================================================
NTSTATUS DriverEntry(IN PDRIVER_OBJECT  pDrvObj,
					 IN PUNICODE_STRING pUniStr)
{
	// Driver Unload Procedure Entry
	pDrvObj->DriverUnload					= Entry_Unload;

	// PnP Procedure Entry
	pDrvObj->DriverExtension->AddDevice		= Entry_AddDevice;
	pDrvObj->MajorFunction[IRP_MJ_PNP]		= Entry_DispatchPnp;

	// Power Procedure Entry
	pDrvObj->MajorFunction[IRP_MJ_POWER]	= Entry_DispatchPower;

	// Device I/O Control Procedure Entry
	pDrvObj->MajorFunction[IRP_MJ_CREATE]	= Entry_DispatchCreate;
	pDrvObj->MajorFunction[IRP_MJ_CLOSE]	= Entry_DispatchClose;

	return (NTSTATUS)STATUS_SUCCESS;
}


//==============================================================================
//
// Entry_Unload
//
// ̹ ޸𸮿 Unload ɶ ȴ. I/O Manager DriverEntry
// ƾ    Լ ȣϸ, PnP Manager IRP_MN_REMOVE_DEVICE
// ó ̻ ִ DeviceObject ÿ  Լ ȣѴ.
//
// IRQL: It is run in the context of a system thread at IRQL PASSIVE_LEVEL.
//
//==============================================================================
NTSTATUS Entry_Unload(IN PDRIVER_OBJECT pDrvObj)
{
	return (NTSTATUS)STATUS_SUCCESS;
}


//==============================================================================
//
// Entry_AddDevice
//
// PnP Manager  ̹ ´ ġ ˻ DeviceObject 
// ϱ   ƾ Ѵ.
//
// IRQL: It is run in the context of a system thread at IRQL PASSIVE_LEVEL.
//
//==============================================================================
NTSTATUS Entry_AddDevice(IN PDRIVER_OBJECT pDrvObj,
						 IN PDEVICE_OBJECT pPdo)
{
	NTSTATUS status = STATUS_SUCCESS;

	PDEVICE_OBJECT		pFdo	= NULL;
	PDEVICE_EXTENSION	pDevExt	= NULL;

	PAGED_CODE();

	// Device Object ..
	status = IoCreateDevice(pDrvObj, sizeof(DEVICE_EXTENSION),
			NULL, FILE_DEVICE_UNKNOWN, 0, TRUE, &pFdo);
	if( !NT_SUCCESS(status) ) { return (NTSTATUS)status; }

	// Device Extension PDO   IOPLʱȭ..
	pDevExt = (PDEVICE_EXTENSION)pFdo->DeviceExtension;
	pDevExt->pPdo = pPdo;
	pDevExt->m_pIOPL = NULL;	// IOPL  ʱȭ

	// Device Interface ...
	status = IoRegisterDeviceInterface(
		pPdo, &ZAPIO_GUID, NULL, &pDevExt->SymLinkName);
	if( !NT_SUCCESS(status) ) {
		IoDeleteDevice(pFdo);
		return (NTSTATUS)status;
	}

	// Device Interface Ȱȭ..
	status = IoSetDeviceInterfaceState(&pDevExt->SymLinkName, FALSE);
	if( !NT_SUCCESS(status) ) {
		IoDeleteDevice(pFdo);
		return (NTSTATUS)status;
	}

	// Device Stack Device Object ..
	pDevExt->pNextDevObj = IoAttachDeviceToDeviceStack(pFdo, pPdo);

	// I/O   ʱȭ ڵ .
	pFdo->Flags |= DO_BUFFERED_IO;
	pFdo->Flags &= ~DO_DEVICE_INITIALIZING;

	return (NTSTATUS)status;
}


//==============================================================================
//
// Entry_DispatchPower
//
// Power Manager I/O Manager   Power IRP óѴ. ⼭
// ܼ IRP  ̹ ó   ֵ ϰ  ° ȯѴ.
//
// IRQL: Minor ڵ忡  ִ.
//
//==============================================================================
NTSTATUS Entry_DispatchPower(IN PDEVICE_OBJECT pFdo,
							 IN PIRP pIrp)
{
	PDEVICE_EXTENSION pDevExt = (PDEVICE_EXTENSION)pFdo->DeviceExtension;

	//
	// IRQL: this routine must be running at PASSIVE_LEVEL.
	//
	PoStartNextPowerIrp(pIrp);
	IoSkipCurrentIrpStackLocation(pIrp);

	return (NTSTATUS)PoCallDriver( pDevExt->pNextDevObj, pIrp );
}


//==============================================================================
//
// Entry_DispatchPnp
//
//  Լ PnP Manager I/O Manager   IRP_MJ_PNP IRP
// Minor ڵ带 ġ ϴ Լ̴.
//
// IRQL: Minor Irp Code  Ѵ.
//
//==============================================================================
NTSTATUS Entry_DispatchPnp(IN PDEVICE_OBJECT pFdo,
						   IN PIRP pIrp)
{
	KEVENT event;
	NTSTATUS status = STATUS_SUCCESS;

	PIO_STACK_LOCATION pCurStack = IoGetCurrentIrpStackLocation(pIrp);
	PDEVICE_EXTENSION  pDevExt   = (PDEVICE_EXTENSION)pFdo->DeviceExtension;

	switch(pCurStack->MinorFunction)
	{
	//
	// IRQL: The PnP Manager sends this IRP at IRQL PASSIVE_LEVEL in the
	//       context of a system thread.
	//
	case IRP_MN_START_DEVICE:
		{
			//  ̹  ʱȭ ۾ ϵ Ѵ.
			KeInitializeEvent(&event, NotificationEvent, FALSE);

			IoCopyCurrentIrpStackLocationToNext(pIrp);
			IoSetCompletionRoutine(pIrp, Dispatch_CompletionRoutine, (PVOID)&event, TRUE, TRUE, TRUE);

			status = IoCallDriver(pDevExt->pNextDevObj, pIrp);
			if(status == STATUS_PENDING) {
				KeWaitForSingleObject((PVOID)&event, Executive, KernelMode, FALSE, NULL);
				status = pIrp->IoStatus.Status;
			}
			if( !NT_SUCCESS(status) ) {
				return (NTSTATUS)Dispatch_CompleteRequest(pIrp,
					pIrp->IoStatus.Status,
					pIrp->IoStatus.Information);
			}

			// Device Interface Ȱȭ Ų.
			status = IoSetDeviceInterfaceState(&pDevExt->SymLinkName, TRUE);
		}
		break;

	//
	// IRQL: The PnP Manager sends this IRP at IRQL PASSIVE_LEVEL in the
	//       context of a system thread.
	//
	case IRP_MN_REMOVE_DEVICE:
		{
			// Device Interface  Ѵ.
			IoSetDeviceInterfaceState(&pDevExt->SymLinkName, FALSE);
			RtlFreeUnicodeString(&pDevExt->SymLinkName);

			//  ̹  IRP óϵ Ѵ.
			IoSkipCurrentIrpStackLocation(pIrp);
			status = IoCallDriver(pDevExt->pNextDevObj, pIrp);

			// Device Object ıѴ.
			if(pDevExt->pNextDevObj != NULL) { IoDetachDevice(pDevExt->pNextDevObj); }
			IoDeleteDevice(pFdo);
		}
		break;
	
	//
	// Default Handler
	//
	default:
		{
			//  ̹ IRP ó ѱ.
			IoSkipCurrentIrpStackLocation(pIrp);
			status = IoCallDriver(pDevExt->pNextDevObj, pIrp);
		}
		break;
	}
	
	return (NTSTATUS)status;
}


//==============================================================================
//
// Entry_DispatchCreate
//
// IRP_MJ_CREATE ڵ鷯 Լ̴.
//
// IRQL: ȣ  IRQL ȣǸ, Ϲδ PASSIVE_LEVEL
//       ַ ȣȴ.
//
//==============================================================================
NTSTATUS Entry_DispatchCreate(IN PDEVICE_OBJECT pFdo,
							  IN PIRP pIrp)
{
	NTSTATUS status = STATUS_SUCCESS;
	PDEVICE_EXTENSION  pDevExt   = (PDEVICE_EXTENSION)pFdo->DeviceExtension;

	PAGED_CODE();

	// ȣ ´.
	if(pDevExt->m_pIOPL != NULL) {
		goto $end;
	}

	// I/O .
	pDevExt->m_pIOPL = MmAllocateNonCachedMemory( sizeof(IOPM) );
	if(pDevExt->m_pIOPL != NULL) {
		RtlZeroMemory(pDevExt->m_pIOPL, sizeof(IOPM));
		
		Ke386IoSetAccessProcess(PsGetCurrentProcess(), 1);
		Ke386SetIoAccessMap(1, pDevExt->m_pIOPL);
	}
	else {
		status = STATUS_INSUFFICIENT_RESOURCES;
	}

$end:
	return (NTSTATUS)Dispatch_CompleteRequest(pIrp, status, 0);
}


//==============================================================================
//
// Entry_DispatchClose
//
// IRP_MJ_CLOSE ڵ鷯 Լ̴.
//
// IRQL: ȣ  IRQL ȣǸ, Ϲδ PASSIVE_LEVEL
//       ַ ȣȴ.
//
//==============================================================================
NTSTATUS Entry_DispatchClose(IN PDEVICE_OBJECT pFdo,
							 IN PIRP pIrp)
{
	PDEVICE_EXTENSION  pDevExt   = (PDEVICE_EXTENSION)pFdo->DeviceExtension;

	PAGED_CODE();

	if(pDevExt->m_pIOPL) {
		Ke386IoSetAccessProcess(PsGetCurrentProcess(), 0);
		Ke386SetIoAccessMap(1, pDevExt->m_pIOPL);

		MmFreeNonCachedMemory(pDevExt->m_pIOPL, sizeof(IOPM));
		pDevExt->m_pIOPL = NULL;
	}

	return (NTSTATUS)Dispatch_CompleteRequest(pIrp, STATUS_SUCCESS, 0);
}


//==============================================================================
//
// Dispatch_CompleteRequest
//
// IRP ó Ϸ IRP  Ʈ ϰ I/O Manager IRP
// ȯѴ.
//
// IRQL: this routine must be running at IRQL <= DISPATCH_LEVEL.
//
//==============================================================================
NTSTATUS Dispatch_CompleteRequest(IN PIRP pIrp,
								  IN NTSTATUS status,
								  IN ULONG information)
{
	pIrp->IoStatus.Status		= status;
	pIrp->IoStatus.Information	= information;

	//
	// IRQL: this routine must be running at IRQL <= DISPATCH_LEVEL.
	//
	IoCompleteRequest( pIrp, IO_NO_INCREMENT );

	return (NTSTATUS)status;
}


//==============================================================================
//
// Dispatch_CompletionRoutine
//
// Competion Routine̴.  ƾ ̹ 尡 Wait ¸
//  ؼ ̺Ʈ ȣ(Signaled) ٲٴ  Ѵ.
//
// IRQL: it is run in the a context of system thread at IRQL PASSIVE_LEVEL.
//
//==============================================================================
NTSTATUS Dispatch_CompletionRoutine(IN PDEVICE_OBJECT pFdo,
									IN PIRP pIrp,
									IN PVOID pEvent)
{
	PAGED_CODE();

	//
	// IRQL: this routine must be running at IRQL PASSIVE_LEVEL and in a
	//       nonarbitrary thread context.
	//
	KeSetEvent((PRKEVENT)pEvent, 0, FALSE);

	return (NTSTATUS)STATUS_MORE_PROCESSING_REQUIRED;
}
